#ifndef EP_LIB_ENDPOINT_HPP_INCLUDED
#define EP_LIB_ENDPOINT_HPP_INCLUDED

namespace ep_lib
{

  typedef void* MPI_Datatype;
  typedef void* MPI_Op;


  int MPI_Barrier_endpoint(MPI_Comm comm);

  int MPI_Comm_free_endpoint(MPI_Comm* comm);

  int Message_Check_endpoint(MPI_Comm comm);
  
  int MPI_Comm_dup_endpoint(MPI_Comm comm, MPI_Comm *newcomm);
  
  int MPI_Iprobe_endpoint(int source, int tag, MPI_Comm comm, int *flag, MPI_Status *status);
  int MPI_Improbe_endpoint(int source, int tag, MPI_Comm comm, int *flag, MPI_Message *message, MPI_Status *status);
  
  int MPI_Intercomm_create_endpoint(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);

}

#endif // EP_LIB_ENDPOINT_HPP_INCLUDED
